<?php

namespace Farfetch\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Save ServiceType
 * @subpackage Services
 */
class Save extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SaveGeoBrandPrices
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Farfetch\StructType\SaveGeoBrandPrices $parameters
     * @return \Farfetch\StructType\SaveGeoBrandPricesResponse|bool
     */
    public function SaveGeoBrandPrices(\Farfetch\StructType\SaveGeoBrandPrices $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SaveGeoBrandPrices($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Farfetch\StructType\SaveGeoBrandPricesResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
